#ifndef __ipsc_h__
#define __ipsc_h__

struct network {
	/* Network and class information */
	char    class;
        int     addr;
        int     bits;
	int 	mask;

        /* Subnet information */
	int     subnet_max;
      	int     subnet_bits;
	int	subnet_bits_max;

	int	subnet_mask;

	/* Host specific information */
        int     host_bits;	
        int     host_max;
	int	host_addr;
	int	host_network_lbound; 	/* first address in host subnet */
	int	host_network_ubound; 	/* last address in host subnet */

	/* Miscellaneous */
	int	rfc1878;		/* allow subnets of all ones or zeros */
	int 	cisco_wildcard;
	char	bitmap[35];
};

int get_class_info(struct network *n, char class, const int reset_host);
int get_interface_info(struct network *n, const char *if_name);
char **get_interface_names(int *if_count);
int incorrect_subnet_bits(struct network *n);
void set_network_info(struct network *n);
void get_bitmap(struct network *n);
void free_interface_names(char **if_names, const int if_count);

void fprint_general(FILE *f, const struct network *n);
void fprint_subnets_hosts(FILE *f, const struct network *n);
void fprint_host(FILE *f, const struct network *n);
void fprint_cidr(FILE *f, const struct network *n);

#endif
